Ruby - Bug #17812

Timeout::Error doesn't let two-argument raise() set a new message
04/17/2021 09:00 PM - martin.dorey@hds.com (Martin Dorey)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.5.5p157 (2019-03-15 revision Backport: 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0:
67260) [x86_64-linux-gnu] UNKNOWN

Description

Shouldn't this:

martind@pizzagate:~$ ruby -we 'require "timeout"; raise(Timeout::Error.new("hello"), "world")'
Traceback (most recent call last):

—e:1l:in "<main>': hello (Timeout::Error)

martind@pizzagate:~$

... say "world", like this:

martind@pizzagate:~$ ruby -we 'raise (RuntimeError.new("hello"), "world")'
Traceback (most recent call last):

—e:1l:in “<main>': world (RuntimeError)

martind@pizzagate:~$

... rather than "hello"?
Sorry to raise an issue against such an old version but, if I'm right about the cause being that Timeout::Error#exception ignores its

arguments, then that, judging by
https://github.com/ruby/ruby/blob/3d32c217586a48c709b762865a8abc46f9098455/lib/timeout.rb#L. 38, hasn't changed since.

| have a work around for what I'm trying to do, which is generic code to re-raise an exception with some added information, so | don't
need a fix or help, but | wanted to do my little bit to help Ruby have fewer surprises. | was interested to discover, in doing this, the
new :cause option. | did try to check that I'm not raising a duplicate, but sorry if | failed.

Associated revisions

Revision 33b5e179a88e67f1ee12e2e8993121b2f445b54f - 05/06/2021 07:49 AM - jeremyevans (Jeremy Evans)

[ruby/timeout] Make Timeout::Error#exception with multiple arguments not ignore arguments
This makes:
raise(Timeout::Error.new("hello"), "world")

raise a TimeoutError instance with "world" as the message instead
of "hello", for consistency with other Ruby exception classes.

This required some internal changes to keep the tests passing.
Fixes [Bug #17812]

https://github.com/ruby/timeout/commit/952154dbf9

Revision 33b5e179a88e67f1ee12e2e8993121b2f445b54f - 05/06/2021 07:49 AM - jeremyevans (Jeremy Evans)

[ruby/timeout] Make Timeout::Error#exception with multiple arguments not ignore arguments
This makes:
raise(Timeout::Error.new("hello"), "world")

raise a TimeoutError instance with "world" as the message instead
of "hello", for consistency with other Ruby exception classes.

This required some internal changes to keep the tests passing.
https://github.com/ruby/ruby/blob/3d32c217586a48c709b762865a8abc46f9098455/lib/timeout.rb#L38
https://github.com/ruby/timeout/commit/952154dbf9

Fixes [Bug #17812]

https://github.com/ruby/timeout/commit/952154dbf9

Revision 33b5e179 - 05/06/2021 07:49 AM - jeremyevans (Jeremy Evans)

[ruby/timeout] Make Timeout::Error#exception with multiple arguments not ignore arguments
This makes:
raise(Timeout::Error.new("hello"), "world")

raise a TimeoutError instance with "world" as the message instead
of "hello", for consistency with other Ruby exception classes.

This required some internal changes to keep the tests passing.
Fixes [Bug #17812]

https://github.com/ruby/timeout/commit/952154dbf9

History

#1 - 04/20/2021 05:45 PM - jeremyevans0 (Jeremy Evans)
I've submitted a pull request to fix this: https:/github.com/ruby/timeout/pull/3

#2 - 05/03/2021 03:44 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed
